﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

namespace SwrCnfg
{
    public partial class DxChart1 : UserControl
    {
        public DxChart1()
        {
            InitializeComponent();

            Paint += new PaintEventHandler(DxChart1_Paint);
        }

        Pen penGrid = new Pen(Color.Black);
        Pen penSeries1 = new Pen(Color.Red);
        Pen penSeries2 = new Pen(Color.Blue);
        Font font = new Font(FontFamily.GenericSansSerif, 10);
        Brush brush = Brushes.Black;

        private void DxChart1_Paint(object sender, PaintEventArgs e)
        {
            const int leftBorder = 35;
            const int rightBorder = 65;
            const int topBorder = 7;
            const int bottomBorder = 20;
            const int xgrid = 16; // kolik mrizi
            const int ygrid = 8; // kolik mrizi

            string tmpStr;

            int yStep = (this.Height - topBorder - bottomBorder) / ygrid;
            int xStep = (this.Width - leftBorder - rightBorder) / xgrid;

            for (int i = 0; i < ygrid+1; i++)
            {
                e.Graphics.DrawLine(penGrid, new Point(leftBorder, topBorder + i * yStep), new Point(leftBorder + xgrid * xStep, topBorder + i * yStep)); // horizontalni
                e.Graphics.DrawString((1024/ygrid*(ygrid-i)).ToString(), font, Brushes.Black, new Point(0, topBorder + i * yStep - (int)font.GetHeight()/2));
            }

            for (int i = 0; i < xgrid+1; i++)
            {
                e.Graphics.DrawLine(penGrid, new Point(leftBorder + i * xStep, topBorder), new Point(leftBorder + i * xStep, topBorder + ygrid * yStep)); // vertikalni
                tmpStr = (1024/xgrid * i).ToString();
                int strPixels = (int)e.Graphics.MeasureString(tmpStr, font).Width;
                e.Graphics.DrawString(tmpStr, font, Brushes.Black, new Point(leftBorder + i * xStep - strPixels/2, topBorder + ygrid * yStep));
            }
            e.Graphics.DrawString("ADC raw", font, Brushes.Red, new Point(leftBorder + xgrid * xStep + 2,10));
            e.Graphics.DrawString("ADC comp", font, Brushes.Blue, new Point(leftBorder + xgrid * xStep + 2, 10 + (int)font.GetHeight()));

            try
            {
                Point lastPoint1 = new Point(0,0);
                Point lastPoint2 = new Point(0, 0);
                DataTable tbl = source.Tables[0];
                foreach (DataRow row in tbl.Rows)
                {
                    short adcraw = (short)row.ItemArray[0];
                    short adccor = (short)row.ItemArray[1];
                    
                    Point pt = new Point (leftBorder + (adcraw * xStep * xgrid)/1024, topBorder + ((1024 -adcraw)* ygrid *yStep)/1024);
                    if (lastPoint1 != new Point(0,0))
                        e.Graphics.DrawLine(penSeries1, lastPoint1, pt);
                    lastPoint1 = pt;

                    pt = new Point(leftBorder + (adcraw * xStep * xgrid) / 1024, topBorder + ((1024 - adccor) * ygrid * yStep) / 1024);
                    if (lastPoint2 != new Point(0, 0))
                        e.Graphics.DrawLine(penSeries2, lastPoint2, pt);
                    lastPoint2 = pt;
                }
            }
            catch{}
        }
    }
}
